\documentclass[11pt,a4paper]{article}

\voffset=-1.5cm \hoffset=-1.4cm \textwidth=16cm \textheight=22.0cm

\usepackage{graphicx}
\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{mathrsfs}
\usepackage{enumerate}
\usepackage{lscape}
\usepackage{longtable}
\usepackage{rotating}
\usepackage{multirow}
\usepackage{color}
\usepackage{xcolor}
\usepackage{url}
\usepackage{subfigure}
\usepackage{rotating}
\usepackage{hyperref}

\usepackage[english]{babel}
\usepackage{biblatex}
\usepackage{blkarray}% http://ctan.org/pkg/blkarray

\addbibresource{main.bib}
+
\hypersetup{
    colorlinks=true, %set true if you want colored links
    linktoc=all,     %set to all if you want both sections and subsections linked
    linkcolor=blue,  %choose some color if you want links to stand out
}
\newcommand{\matindex}[1]{\mbox{\scriptsize#1}}% Matrix index
\newtheorem{theorem}{Theorem}[section]
\newtheorem{acknowledgment}{Acknowledgment}[section]
\usepackage[ruled,vlined,noline,linesnumbered]{algorithm2e}
\newtheorem{axiom}{Axiom}[section]
\newtheorem{case}{Case}[section]
\newtheorem{claim}{Claim}[section]

\newtheorem{conclusion}{Conclusion}[section]
\newtheorem{condition}{Condition}[section]
\newtheorem{conjecture}{Conjecture}[section]
\newtheorem{corollary}{Corollary}[section]
\newtheorem{criterion}{Criterion}[section]
\newtheorem{definition}{Definition}[section]
\newtheorem{example}{Example}[section]
\newtheorem{exercise}{Exercise}[section]
\newtheorem{lemma}{Lemma}[section]
\newtheorem{notation}{Notation}[section]
\newtheorem{problem}{Problem}[section]
\newtheorem{proposition}{Proposition}[section]
\newtheorem{remark}{Remark}[section]
\newtheorem{solution}{Solution}[section]
\newtheorem{assumption}{Assumption}[section]
\newtheorem{summary}{Summary}[section]
\newtheorem{note}{Note}[section]
\newtheorem{doubt}{Doubt}[section]
\newtheorem{properties}{Properties}[section]
\newenvironment{proof}[1][Proof]{\textbf{#1.} }{\ \rule{0.5em}{0.5em} \vspace{1ex}}

\newcommand{\udef}{\mathrel{\mathop:}=}
\newcommand{\defu}{=\mathrel{\mathop:}}
\newcommand{\dd}{{\rm d}}
\newcommand{\R}{\mathbb{R}}
\newcommand{\Q}{\mathbb{Q}}
\newcommand{\N}{\mathbb{N}}
\newcommand{\Z}{\mathbb{Z}}
\newcommand{\C}{\mathbb{C}}
\newcommand{\de}{\mathrm{d}}
\usepackage{dsfont}
\newcommand{\1}{\mathds{1}}
\newcommand{\partialc}{\partial^c} 
\newcommand{\parder}[2]{\frac{\partial#1}{\partial#2}}
\newcommand{\der}[2]{\frac{\de#1}{\de#2}}
% Def abs e norm

\newcommand{\MT}[1]{\textcolor{cyan}{[Marek comment]: #1}}

\usepackage{algorithmic}

\setlength{\unitlength}{1mm}

\def\real{\R}

\DeclareMathOperator{\argmax}{argmax}
\DeclareMathOperator{\argmin}{argmin}
\DeclareMathOperator{\range}{Range}
\DeclareMathOperator{\kernel}{Ker}
\DeclareMathOperator{\cl}{cl}

\addbibresource{main.bib}
\begin{document}

\title{Structural Engineering for Timevarying Loads \\ with a Finite Number of Harmonics}

% Saman Khorramian,Vyacheslav Kungurtsev, Jakub Marecek
\author{ Saman Khorramian, Shenyuan Ma, Allahkaram Shafie,  \\ Vyacheslav Kungurtsev, Marek Tyburec, Jakub Marecek
\thanks{All authors are at the Czech Technical University.}}% <-this % stops a space
\maketitle

\begin{abstract}

\end{abstract}

 \section{Introduction} 
Throughout, $M(a)$ and $K(a)$ are matrices and $f(t)$ is a vector function.
 These are assumptions:
 \begin{itemize}
	\item[\it (i)]
The vector function $f(t)$ is the vector of forces applied to nodes.
	\item[\it (ii)]
The mass matrices of the truss: $M(a)=a_1M_1+\dots+a_nM_n$ \MT{ with $M_i \in \mathbb{S}^{n_\mathrm{dof}}_{\succeq 0}$. Moreover, $M(a) \succ 0$ if $\forall i: a_i>0$}.
	\item[\it (iii)]
The stiffness matrices of the truss: $K(a)=a_1K_1+\dots+a_nK_n$ \MT{ with $K_i \in \mathbb{S}^{n_\mathrm{dof}}_{\succeq 0}$. Moreover, $K(a) \succ 0$ if $\forall i: a_i>0$}.
	\item[\it (iv)]
The vector function $V(t)$ is the vector of nodal velocities and is obtained from the following Matrix Differential Equation: $M(a)V^{\prime \prime}(t)+K(a)V(t)=f^{\prime}(t)$.
	\item[\it (v)]
$C(a_1,\dots,a_n):=\text{limsup}_{t \rightarrow \infty}{f(t)}^{T}V(t)$ (Peak steady-state power delivered to the stucture)
\item[\it (vi)]
The mass of the structure $q_1a_1+\dots+q_na_n$ is lower than $m$.
\item[\it (vii)]
The components of the vector function $f(t)$ have finite Fourier expansions(This assumption is added now and is not in the original paper).
\end{itemize}
With these assumptions, we want to solve the following minimization problem:
\begin{align*}
 {\text{minimize}}&_{(a_1,\dots,a_n)} C(a_1,\dots,a_n)\\
&q_1a_1+\dots+q_na_n \leq m\\   
\end{align*}

\subsection{Matrix Differential Equation}
Regarding structural engineering texts, if $f(t)=(f_{1}(t),f_{2}(t))$, $M$ and $K$ (mass and stiffness matrices of the truss) are $2 \times 2$ matrices, if $f(t)=(f_{1}(t),f_{2}(t),f_{3}(t))$, $M$ and $K$  are $3 \times 3$ matrices, and so on. For simplicity, we solve the problem by considering $f(t)=(f_{1}(t),f_{2}(t))$. The general case ($f(t)=(f_{1}(t),\dots,f_{n}(t))$) is solved in a similar way. Suppose the matrix differential equation is as follows: 
$$M(a)V^{\prime \prime}(t)+K(a)V(t)=f^{\prime}(t)=\begin{bmatrix}  \sum_{k=1}^{N}kb_{1,k}\cos(kt)-ka_{1,k}\sin(kt) \\ \sum_{k=1}^{N} kb_{2,k}\cos(kt)-ka_{2,k}\sin(kt) \end{bmatrix},$$ 
where
\begin{align*}
& M(a)=a_1M_1+a_2M_2=\begin{bmatrix} a_1m_{1,1} & a_2m_{1,2}\\a_1 m_{2,1} & a_2m_{2,2} \end{bmatrix}\\
&K(a)=a_1K_1+a_2K_2=\begin{bmatrix} a_1k_{1,1} & a_2k_{1,2}\\a_1 k_{2,1} & a_2k_{2,2} \end{bmatrix}.
\end{align*}
\MT{The above is incorrect. $K_i$ and $M_i$ are symmetric matrices. Thus, the element of the matrix $M$ and the $j$-th row and $\ell$-th column is $M_{j,\ell} = \sum_{i=1}^{n} M_{i,j,\ell} a_i$, where $M_{i,j,\ell}$ is the element of the $j$-th row and $\ell$-th column of $M_{i}$. Similarly for the matrices $K$. Notation can definitely be simplified, but I will get to this later.}

Let us also assume that $K(a)-k^2M(a)$ is invertible. Now we claim that $V$, which is defined below, is the solution of the matrix differential equation: 
\begin{align*}
 V(t)&=\sum_{k=1}^{N}k(b_{1,k}\cos(kt)-a_{1,k}\sin(kt))(K(a)-k^2M(a))^{-1}\begin{bmatrix} 1 \\ 0 \end{bmatrix}\\
&+\sum_{k=1}^{N}k(b_{2,k}\cos(kt)-a_{2,k}\sin(kt))(K(a)-k^2M(a))^{-1}\begin{bmatrix} 0 \\ 1 \end{bmatrix}.
\end{align*}
we have 
\begin{align*}
 V^{\prime \prime}(t)&= \sum_{k=1}^{N}k^3(-b_{1,k}\cos(kt)+a_{1,k}\sin(kt))(K(a)-k^2M(a))^{-1}\begin{bmatrix} 1 \\ 0 \end{bmatrix}\\
&+\sum_{k=1}^{N}k^3(-b_{2,k}\cos(kt)+a_{2,k}\sin(kt))(K(a)-k^2M(a))^{-1}\begin{bmatrix} 0 \\ 1 \end{bmatrix}.
\end{align*} 
Thus, 
\begin{align*}
&M(a)V^{\prime \prime}(t)+K(a)V(t)\\
&=\sum_{k=1}^{N}(K(a)-k^2M(a))k(b_{1,k}\cos(kt)-a_{1,k}\sin(kt))(K(a)-k^2M(a))^{-1}\begin{bmatrix} 1 \\ 0 \end{bmatrix}\\
&+\sum_{k=1}^{N}(K(a)-k^2M(a))k(b_{2,k}\cos(kt)-a_{2,k}\sin(kt))(K(a)-k^2M(a))^{-1}\begin{bmatrix} 0 \\ 1 \end{bmatrix}\\
&= \sum_{k=1}^{N}k(b_{1,k}\cos(kt)-a_{1,k}\sin(kt))\begin{bmatrix} 1 \\ 0 \end{bmatrix}\\
&+\sum_{k=1}^{N}k(b_{2,k}\cos(kt)-a_{2,k}\sin(kt))\begin{bmatrix} 0 \\ 1 \end{bmatrix}\\
&=f^{\prime}(t).
\end{align*} 

\[\mathop {\max }\limits_n f\]
So, for the general case, the bilevel problem is again a bilevel POP. Although the condition of invertibility for $K(a)-k^2M(a)$ should be added to the constraints, this would not be a challenge since the bilevel POP in Lasserre's paper also covers this situation. Moreover, in structural engineering (in the texts I have read so far) M is a diagonal matrix and K is a symmetric matrix. \MT{$K$ is always symmetric and positive semidefinite. Similarly, the mass matrix $M$ is always symmetric and positive semidefinite.} Under these assumptions, the condition of invertibility for $K(a)-k^2M(a)$ would even be in a simpler version. \MT{I still don't see how to do it.} All in all, the work on this article seems to be almost finished if we can solve the following problems:\\
\textbf{Problem(1)}

\begin{align*}
 &{\text{minimize}}_{(a,b)\in {\mathbb{R}}^2} C(a,b)\\
&~~~~~~~~~~5a+7b \leq 3\\
s.t~~&C(a,b)=\text{Max}_{x \in [-1,1]}\frac{3}{a+b}(x^3+5x^2+1)+\frac{1}{2a+3b}(6x^4+3x^3+2x+5)
\end{align*}

\textcolor{blue}{Arash: Note that the function $C$ is not, continuous, smooth, convex, or concave. Owing to the asymptotic behavior of objective function $C$ it could not be docile possibly, since the constraint wants to be cut by affine plans $a+b\ne0$ and $2a+3b\ne0$ which means that finding minimization over cut boundaries will be problematic, e.g., 
\begin{align*}
    \nexists\left\{ \begin{gathered}
  ~~~~{\rm min}~ a^2, \hfill \\
 {\rm s.t}~ a\in[-1,1], a\ne0. \hfill \\ 
\end{gathered}  \right.
\end{align*}
Precisely speaking, this constraint needs to be refined further, in such cases, there is no minimization of objective $C$. Take ${\rm min}_{(a,b)\in\mathbb{R}^2} C(a,b)=C(a_0,b_b)$ and set $a=b=t$ we then have 
\[C(t,t)\ge C(a_0,b_0)~~~~\forall t\in(-\infty,\frac{1}{4}]\] which follows that 
\begin{align*}
    C(t,t)&={\rm Max}_{x\in[-1,1]}\frac{3}{2t}(x^3+5x^2+1)+\frac{1}{5t}(6x^4+3x^3+2x+5)\\&=\frac{1}{t}{\rm Max}_{[-1,1]}(\frac{6}{5}x^4+\frac{21}{10}x^3+\frac{15}{2}x^2+\frac{2}{5}x+\frac{2}{5})\\&=\frac{137}{t}
\end{align*}
one gets contradiction by taking $t\to-\infty$ or $t\to0^{-}$.
Moreover, if we consider the problem as
\begin{align*}
(I)\left\{ \begin{gathered}
 ~~{\rm Min}C(a,b) \hfill \\
 ~~{\rm s.t}~0\le5a+7b\le 3, \hfill \\
 C(a,b)={\rm Max}_{x \in [-1,1]}\frac{3}{a+b}(x^3+5x^2+1)+\frac{1}{2a+3b}(6x^4+3x^3+2x+5) \hfill \\ 
\end{gathered}  \right. 
\end{align*}
in such case, there is also no solution to the problem (I), e.g. Let $a=4t, b=-3t$ for all $t\in[-3,0]$, much of a muchness previous, one obtains that  \[\frac{9}{t}\ge C(a_0,b_0)\]
and taking $t\to0^{-}$ derives a contradiction.
}\textcolor{green}{Please see comments in Section 4.}\\\\
\textcolor{blue}{Arash: I am not much pleased with this, for instance you can consider 
\begin{align*}
 &{\text{minimize}}_{(a,b)\in {\mathbb{R}}^2} C(a,b)\\
&~~~~~~~~~~0\le 5a+7b \leq 3,~~a,b\ge0\\
s.t~~&C(a,b)=\mathop{\rm Max}\limits_{x \in [-1,1]}\frac{3}{a+b}(x^3-5x^2-1)+\frac{1}{2a+3b}(6x^4+3x^3+2x+5)
\end{align*}
Now take $a=t$ and $b=0$, then for all $0\le t\le\frac{3}{5}$ one has 
\[C(t,0)=\frac{1}{t}\max_{-1\le x\le 1}[3x^4+\frac{9}{2}x^3-15x^2+x-\frac{1}{2}]=-\frac{1}{2t}\]
which means that $-\frac{1}{2t}\ge C(a^*,b^*)$ (due to $(a^*,b^*)$ is optimal point of main problem) for every $0\le t\le\frac{3}{5}$
which is not possible!}

Let us consider substituting the fractions with new variables:

\begin{align*}
 &{\text{minimize}}_{(a,b)\in {\mathbb{R}}^2} C(a,b)\\
&~~~~~~~~~~5a+7b \leq 3\\
s.t~~&C(a,b)=\text{Max}_{x \in [-1,1], (d,e)\in {\mathbb{R}^2}} \quad d(x^3+5x^2+1)+e(6x^4+3x^3+2x+5)\\
& \quad \quad \quad s.t.~~ (a+b) d = 3 \\ 
& \quad \quad \quad ~~~~ (2a+3b) e = 1 
\end{align*}

Now, we need to check that the problem satisfies the assumptions of Lasserre et al, 
notably non-degeneracy and Slater condition. Slater conditon is not satisfied, but we can 
relax the equalities to obtain:

\begin{align*}
 &{\text{minimize}}_{(a,b)\in {\mathbb{R}}^2} C(a,b)\\
&~~~~~~~~~~5a+7b \leq 3\\
s.t~~&C(a,b)=\text{Max}_{x \in [-1,1], (d,e,s)\in {\mathbb{R}^3}} \quad d(x^3+5x^2+1)+e(6x^4+3x^3+2x+5)\\
& \quad \quad \quad s.t.~~ |(a+b) d - 3| \le s \\ 
& \quad \quad \quad ~~~~ |(2a+3b) e - 1 | \le s \\
& \quad \quad \quad ~~~~ s \le 0.01 \\
\end{align*}


\textbf{Problem(2)}
\begin{align*}
 &{\text{minimize}}_{(a,b)\in {\mathbb{R}}^2} C(a,b)\\
&~~~~~~~~~~5a+7b \leq 3\\
s.t~~&C(a,b)=\text{arg-min}_{x \in [-1,1]}a(x^3+5x^2+1)+b(6x^4+3x^3+2x+5)
\end{align*}
\textcolor{blue}{Arash: This problem dosent seem to make sense, because $C(a,b)$ maybe is a set in some points, i.e., $C(0,0)=[-1,1].$ }
\subsection{Bilevel POP}
Consider the function $f$ as follows: 
$$f(t)=\begin{bmatrix}  a_{1,0}+\sum_{k=1}^{N}a_{1,k}\cos(kt)+b_{1,k}\sin(kt)\\a_{2,0}+\sum_{k=1}^{N} a_{2,k}\cos(kt)+b_{2,k}\sin(kt)\end{bmatrix}.$$ 
The solution of the matrix differential equation for this case will be as follows: 
\begin{align*}
 V(t)&= \sum_{k=1}^{N}k(b_{1,k}\cos(kt)-a_{1,k}\sin(kt))(K(a)-k^2M(a))^{-1}\begin{bmatrix} 1 \\ 0 \end{bmatrix}\\
&+\sum_{k=1}^{N}k(b_{2,k}\cos(kt)-a_{2,k}\sin(kt))(K(a)-k^2M(a))^{-1}\begin{bmatrix} 0 \\ 1 \end{bmatrix}\\
&= \sum_{k=1}^{N}k(b_{1,k}\cos(kt)-a_{1,k}\sin(kt))A_{1,k}\\
&+\sum_{k=1}^{N}k(b_{2,k}\cos(kt)-a_{2,k}\sin(kt))A_{2,k},
\end{align*} 
where $A_{1,k}=(K(a)-k^2M(a))^{-1}\begin{bmatrix} 1 \\ 0 \end{bmatrix};~1\leq k \leq N$ and $A_{2,k}=(K(a)-k^2M(a))^{-1}\begin{bmatrix} 0 \\ 1 \end{bmatrix};~1\leq k\leq N$. We know that the elements of the matrices $A_{1,k};~1\leq k\leq N$ and $A_{2,k};~1\leq k\leq N$ are polynomial fractions, i.e 
$$A_{i,k}=\begin{bmatrix} \frac{Q_{i,k,1}(a_1,a_2,\dots,a_r)}{P_{i,k,1}(a_1,a_2,\dots,a_r)}\\ \\ \frac{Q_{i,k,2}(a_1,a_2,\dots,a_r)}{P_{i,k,2}(a_1,a_2,\dots,a_r)} \end{bmatrix}$$ 
where $Q_{i,k,j}, P_{i,k,j}; i,j \in \lbrace 1,2 \rbrace, 1\leq k\leq N$ are polynomials in $a_1,a_2,\dots,a_r$. So, 
$$V(t)=\begin{bmatrix}\sum_{i=1}^{2} \sum_{k=1}^{N}\frac{Q_{i,k,1}(a_1,a_2,\dots,a_r)}{P_{i,k,1}(a_1,a_2,\dots,a_r)}k(b_{i,k}\cos(kt)-a_{i,k}\sin(kt)) \\ \sum_{i=1}^{2}\sum_{k=1}^{N}\frac{Q_{i,k,2}(a_1,a_2,\dots,a_r)}{P_{i,k,2}(a_1,a_2,\dots,a_r)}k(b_{i,k}\cos(kt)-a_{i,k}\sin(kt)) \end{bmatrix}.$$ 
Then, 
\begin{align*}
 f(t)^TV(t)&= \sum_{i=1}^{2} \sum_{k=1}^{N}\frac{Q_{i,k,1}(a_1,a_2,\dots,a_r)}{P_{i,k,1}(a_1,a_2,\dots,a_r)}k(b_{i,k}\cos(kt)-a_{i,k}\sin(kt))f_1(t)\\
&+\sum_{i=1}^{2}\sum_{k=1}^{N}\frac{Q_{i,k,2}(a_1,a_2,\dots,a_r)}{P_{i,k,2}(a_1,a_2,\dots,a_r)}k(b_{i,k}\cos(kt)-a_{i,k}\sin(kt))f_2(t)\\
&=\sum_{i=1}^{2} \sum_{k=1}^{N}\frac{Q_{i,k,1}(a_1,a_2,\dots,a_r)}{P_{i,k,1}(a_1,a_2,\dots,a_r)}R_{i,k,1}(sin(t),cos(t))\\
&+\sum_{i=1}^{2}\sum_{k=1}^{N}\frac{Q_{i,k,2}(a_1,a_2,\dots,a_r)}{P_{i,k,2}(a_1,a_2,\dots,a_r)}R_{i,k,2}(sin(t),cos(t)),
\end{align*} 
where $R_{i,k,j}(x,y);~i,j \in \lbrace 1,2 \rbrace, 1\leq k\leq N$ are polynomial in $x, y$ such that 
$$R_{i,k,j}(sin(t),cos(t))=k(b_{i,k}\cos(kt)-a_{i,k}\sin(kt))f_j(t).$$ 
Then, the following bilevel POP should be solved: 
\begin{align}\label{eq:mainproblem1}
 &{\text{minimize}}_{(a_1,\dots,a_r)\in {\mathbb{R}}^r} C(a_1,\dots,a_r)\\
&~~~~~~~~~~q_1a_1+\cdots+ q_ra_r \leq m\\
s.t~~&C(a_1,\dots,a_r)=\text{Max}_{x \in [-1,1],~y \in [-1,1],~e_{i,k,j} \in {\mathbb{R}}}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j}R_{i,k,j}(x,y)\\
&~~~~~~~~~~Q_{i,k,j}(a_1,a_2,\dots,a_r)-P_{i,k,j}(a_1,a_2,\dots,a_r)e_{i,k,j}=0;~i,j \in \lbrace 1,2 \rbrace, ~1\leq k\leq N,\\
&~~~~~~~~~~P_{i,k,j}(a_1,a_2,\dots,a_r)\neq 0;~i,j \in \lbrace 1,2 \rbrace,~ 1\leq k\leq N,\\
&~~~~~~~~~~det(K(a)-k^2M(a))\neq 0;~1\leq k\leq N,\\
&~~~~~~~~~~x^2+y^2=1.
\end{align}

\textcolor{blue}{Arash: Please correct me guys, if I am going wrong. One scenario to look at the problem \eqref{eq:mainproblem1} is as follows: at the first attempt the objective function should be well-defined, take $a:=(a_1,...,a_r)$ and $P(a)=\min_{i,j,k}|P_{i,j,k}(a)|$ and $\mathcal{C}_{\epsilon}=\{a\in\R^n:~P(a)\ge\epsilon\}$ and $\mathcal{C}_1=\cup_{\epsilon>0}\mathcal{C}_{\epsilon}$ and $$\mathcal{C}_2=\{a\in\R^n:~0\le a^Tq\le m, K(a)-NM(a)\succeq 0\}$$ Now, let $\mathcal{C}={\rm cl} \mathcal{C}_1\cap\mathcal{C}_2$ and then the main problem states as 
$(II)\left\{ \begin{array}{l}
 {\rm Min}\,C(a) \\ 
 a\in\mathcal{C}  \\ 
 \end{array} \right.$
 where 
 \[C(a) = \mathop {\rm Max}\limits_{(x,y) \in {{[0,1]}^2}} \sum\limits_j {\sum\limits_i {\sum\limits_k {\frac{{{Q_{i,j,k}}(a)}}{{{P_{i,j,k}}(a)}}R(x,y)} } } \]
Note that function $C$ is differentiable over constraint $\mathcal{C}$, hence (II) turns to the minimization problem ${\rm Min_{a\in\R^n}}(C(a)+I_{\mathcal{C}}(a))$ which can be solved by gradient projection method as   
\[a^{k+1}=P_{\mathcal{C}}(x^k-t_k\nabla C(a^k))\]
$t_k$ is step size, constant or determined by line search, that is $a^k\to a^*\in\mathcal{C}$ solution of problem (II)}


\begin{remark}
It should be noted that, here, in the lower-level optimization problem we have Max, while in Lasserre’s paper, it is arg-min. To convert the problem into the format of the formulation in Lasserre’s paper, we first convert the problem to Min by adding two minus: 
\begin{align*}
 &{\text{minimize}}_{(a_1,\dots,a_r)\in {\mathbb{R}}^r} -C(a_1,\dots, a_r)\\
&~~~~~~~~~~q_1a_1+\cdots+ q_ra_r \leq m\\
s.t~~&C(a_1,\dots,a_r)=\text{Min}_{x \in [-1,1],~y \in [-1,1]}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}-\frac{Q_{i,k,j}(a_1,a_2,\dots,a_r)}{P_{i,k,j}(a_1,a_2,\dots,a_r)}R_{i,k,j}(x,y)\\
&~~~~~~~~~~P_{i,k,j}(a_1,a_2,\dots,a_r)\neq 0;~i,j \in \lbrace 1,2 \rbrace, 1\leq k \leq N,\\
&~~~~~~~~~~det(K(a)-k^2M(a))\neq 0;~1\leq k\leqN,\\
&~~~~~~~~~~x^2+y^2=1.
\end{align*}
\end{remark}
Then we change Min to arg-min and replace $C(a_1,\dots, a_r)$ with the lower-level optimization problem in the upper-level optimization problem: 
\begin{align*}
 &{\text{minimize}}_{(a_1,\dots,a_r)\in {\mathbb{R}}^r} \sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}\frac{Q_{i,k,j}(a_1,a_2,\dots,a_r)}{P_{i,k,j}(a_1,a_2,\dots,a_r)}R_{i,k,j}(x,y)\\
&~~~~~~~~~~q_1a_1+\cdots+ q_ra_r \leq m\\
&~~~~~~~~~~det(K(a)-k^2M(a))\neq 0;~1\leq k\leq N,\\
&~~~~~~~~~~x^2+y^2=1.\\
s.t~~&(x,y)=\text{arg-min}_{x \in [-1,1],~y \in [-1,1]}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}-\frac{Q_{i,k,j}(a_1,a_2,\dots,a_r)}{P_{i,k,j}(a_1,a_2,\dots,a_r)}R_{i,k,j}(x,y)\\
&~~~~~~~~~~P_{i,k,j}(a_1,a_2,\dots,a_r)\neq 0;~i,j \in \lbrace 1,2 \rbrace, 1\leq k \leq N.
\end{align*}
\begin{remark}
If we want to use the Bilevel POP structure in Lasserre’s paper (and substitute the fractions with some variables), its generalized form which is mentioned in Remark 4.9 should be used. 
\end{remark}
According to the explanation of the remark, the generalized form can be used if the lower-level optimization problem (by considering Min instead of arg-min) will be continuous. In fact, the continuity of the following function should be proved: 
$$\mathfrak{I}(a_1,\dots, a_r)=\text{Min}_{x \in [-1,1],~y \in [-1,1]}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}\frac{Q_{i,k,j}(a_1,a_2,\dots,a_r)}{P_{i,k,j}(a_1,a_2,\dots,a_r)}R_{i,k,j}(x,y).$$ 
The following function is continuous on $S=\lbrace (a_1,\dots, a_r)\vert P_{i,k,j}(a_1,a_2,\dots,a_r)\neq 0;~i,j \in \lbrace 1,2 \rbrace, 1\leq k\leq N \rbrace$: 
$$f(a_1,\dots, a_r)=(\frac{Q_{1,1,1}(a_1,a_2,\dots,a_r)}{P_{1,1,1}(a_1,a_2,\dots,a_r)},\dots, \frac{Q_{2,N,2}(a_1,a_2,\dots,a_r)}{P_{2,N,2}(a_1,a_2,\dots,a_r)}).$$ 
Therefore, it is enough to show that the following function is continuous: 
$$\mathfrak{I}(e_{1,1,1},\dots, e_{2,N,2})=\text{Min}_{x \in [-1,1],~y \in [-1,1]}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j}R_{i,k,j}(x,y).$$
Suppose $lim_{t\rightarrow \infty}(e_{1,1,1,t},\dots, e_{2,N,2,t})=(e_{1,1,1},\dots, e_{2,N,2})$ and $M=\text{Max}\lbrace \text{Max}_{x \in [-1,1],~y \in [-1,1]} R_{i,k,j}(x,y)\vert ~i,j \in \lbrace 1,2 \rbrace, 1\leq k\leq N \rbrace$. For $\varepsilon>0$ there exist $N_{i,k,j};~i,j \in \lbrace 1,2 \rbrace, 1\leq k\leq N$ such that 
$$\forall t>N_{i,k,j}~\vert e_{i,k,j,t}-e_{i,k,j}\vert<\frac{\varepsilon}{2 \times 2 \times N \times M}$$ 
If $N_{\circ}=Max\lbrace N_{i,k,j}\vert ~i,j \in \lbrace 1,2 \rbrace, 1\leq k\leq N\rbrace$, for each $t>N_{\circ}$ and every $x,y \in [-1,1]$ we have:
$$\vert \sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j}R_{i,k,j}(x,y)-\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j,t}R_{i,k,j}(x,y)\vert< \varepsilon$$ 
or
\begin{align*}
-\varepsilon+\text{Min}_{x \in [-1,1],~y \in [-1,1]}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j,t}R_{i,k,j}(x,y)&<\text{Min}_{x \in [-1,1],~y \in [-1,1]}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j}R_{i,k,j}(x,y)\\
&<\varepsilon+\text{Min}_{x \in [-1,1],~y \in [-1,1]}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j,t}R_{i,k,j}(x,y).
\end{align*}
Therefore, 
$$\vert\text{Min}_{x \in [-1,1],~y \in [-1,1]} \sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j}R_{i,k,j}(x,y)-\text{Min}_{x \in [-1,1],~y \in [-1,1]}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j,t}R_{i,k,j}(x,y)\vert< \varepsilon$$
or 
$$\vert \mathfrak{I}(e_{1,1,1},\dots, e_{2,N,2}) - \mathfrak{I}(e_{1,1,1,t},\dots, e_{2,N,2,t})\vert <\varepsilon$$ 
So, 
$$lim_{t\rightarrow \infty}\mathfrak{I}(e_{1,1,1,t},\dots, e_{2,N,2,t})=\mathfrak{I}(e_{1,1,1},\dots, e_{2,N,2}).$$
Then, $\mathfrak{I}$ is continuous.
\begin{remark}
$R(x,y)$ can be converted into a one-variable polynomial by replacing $y$ with $p(x)$, which is a good approximation of $\sqrt{1-x^2}$. In this case, the constraint $x^2+y^2=1$ will be removed.
\end{remark}
\begin{remark}
We say that $f$ is K-sparse, where $K=card \lbrace k\vert (a_{1,k},b_{1,k}\neq (0,0) or(a_{2,k},b_{2,k}\neq (0,0)  \rbrace$. It should be mentioned that for 1-sparse $f$ not needed to go through the challenging process of bilevel POP. In this case, the process of solution could be very simpler. Therefore, to avoid extra computational tasks in dealing with this case, we can check the type of $f$ in the first step of the algorithm. So, if $f$ was 1-sparse, we guide it to another algorithm including other steps. 
\end{remark}
\subsection{Algorithm}

\section{Shenyuan's comments}
\subsection{Alternative Fourier Coefficients with complex exponential}\label{shenyuan 1}
The expression of the lower level problem can be simplified if we use complex exponential to express Fourier coeffcients. Let $f$ be a real function that is sum of $N$ harmonics. We set :
$$
\forall{t},f(t)=\sum_{|n|\le N}c_n(f)e^{int},
$$
where $c_n(f)\in\mathbb{C}^d$ are the complex Fourier coefficients of $f$. Since $f$ is real, necessarily $c_n(f) = \overline{c_{-n}(f)}$. This approach is equivalent to the previous approach using trigonometric functions. To get the coefficients $a_n$ and $b_n$, we have $a_n=\frac{1}{2}\Re{(c_n(f))}$ and $b_n=\frac{-1}{2}\Im(c_n(f))$, where $\Re$ and $\Im$ stand for the real and imaginary part of complex-valued vector (by taking them element-wise), and $a_0=c_0(f)$.
The matrix differential equations imply that :
$$\begin{array}{ccc}
    K(a)c_0(v) &=&0  \\
     \forall{|n|\ge 1},\left(-n^2M(a)+K(a)\right)c_n(v) &=& inc_n(f) 
\end{array}$$
The function $v(t)$ is also real since the matrix $-n^2M(a)+K(a)$ are all with real entries.

The power delivered to the structure by the time varying loads is thus:
\begin{align}
    \begin{split}
    \forall t, f(t)^Tv(t)=&\sum_{n,m}c_n(f)^T c_m(v) e^{i(n+m)t}\\
                        =&\sum_{l=-2N}^{2N}\underbrace{\sum_{n+m=l}c_n(f)^T c_m(v)}_{=g_l} e^{ilt}\\
                        =&\sum_n c_n(f)^Tc_{-n}(v)+\sum_{l=1}^{2N}\left\{g_le^{ilt}+g_{-l}e^{-ilt}\right\}
    \end{split}           
\end{align}
Furthermore, by the Plancherel's theorem, we have : 
$$
\sum_n c_n(f)^Tc_{-n}(v)=\sum_n c_n(f)^T\overline{c_n(v)}=\frac{1}{2\pi}\int_{0}^{2\pi}f(t)^Tv(t)
$$
The intergral of average power delivered to the structure during one period, in fact, can be proven to be $0$. To notice that, let $u$ be the displacement vector such that $u'=v$, using intergration by part (boundary terms are eliminated using periodicity), the intergral becomes:
\begin{align}
    \begin{split}
    \int_0^{2\pi}f^Tu'=&-\int_{0}^{2\pi}(f)'^Tu \\
                    =&-\left\{\int_{0}^{2\pi}[M(a)v'']^Tu+\int_{0}^{2\pi}[K(a)v]^Tu\right\}
    \end{split}           
\end{align}
Thr first intergral can be further transformed, again using intergration by part : 
\begin{align}
    \begin{split}
    A=\int_0^{2\pi}[M(a)v'']^Tu=&-\int_0^{2\pi}[M(a)v']^Tv\\
                                =&\int_{0}^{2\pi}[M(a)v]^Tv'\\
                                =&\int_{0}^{2\pi}v^T[M(a)v']=-A
    \end{split}           
\end{align}
Thus $A=0$. The calculation holds also for the second intergral. Now we can write $f(t)^Tv(t)$ as follow:
$$
f(t)^Tv(t)=\sum_{l\ge 1}2\Re\left(g_l e^{ilt}\right)=2\sum_{l\ge 1}\Re(g_l)\cos(lt)-\Im(g_l)\sin(lt)
$$. 
The peak power is thus 
$$
C(a_1,\dots,a_r)=\max_{t\in[0,2\pi]}2\sum_{l\ge 1}\Re(g_l)\cos(lt)-\Im(g_l)\sin(lt).
$$
\subsection{Express lower level problem with polynomials}\label{laplace eqn}
Let $\gamma=\{z\in\mathbb{C},|z|=1\}$ be the complex unity circle, the lower level problem can be expressed as :
$$
C(a_1,\dots,a_r)=\max_{z\in\gamma}2\sum_{l\ge 1}\Re\left(g_l z^l\right)
$$
$\forall z\in\gamma$, there is a unique pair $(x,y)\in\mathbb{R}^2$ such that $z=x+iy$ and $x^2+y^2=1$. By Newton's binomial formula, we can get polynomials $p_l$ and $q_l$ such that :
$$
\forall l\ge 1, z^l= p_l(x,y)+q_l(x,y)i
$$
The lower level problem is thus to compute :
$$
C(a_1,\dots,a_r)= \left\{\begin{array}{cc}
     \max_{(x,y)\in\mathbb{R}^2} &  2\sum_{l\ge 1}\Re(g_l)p_l(x,y)-\Im(g_l)q_l(x,y)\\
     \text{s.t.}& x^2+y^2=1
\end{array}\right.
$$
The Slater condition is not satisfied due to the equality constraints. It is possible to replace the constraint $x^2+y^2=1$ by $x^2+y^2\le 1$, which has non empty interior. \textcolor{green}{Please see comments in Section 4.}

Indeed, since the complex valued function $z\mapsto z^l$ is complex-differentiable, $p_l$ and $q_l$ satisfy the Cauchy-Riemann equations which read : 
$$
\left\{\begin{array}{cc}
     \frac{\partial}{\partial x}p_l=& \frac{\partial}{\partial y}q_l \\
     \frac{\partial}{\partial y}p_l=& -\frac{\partial}{\partial x}q_l 
\end{array}\right.
$$
which further implies $\triangle p_l = \triangle q_l = 0$, where $\triangle$ is the Laplacian differential operator $\frac{\partial^2}{\partial x^2}+\frac{\partial^2}{\partial y^2}$. The lower level function $2\sum_{l\ge 1}\Re(g_l)p_l-\Im(g_l)q_l$ is in fact the solution of the Laplacian equation, to which the maximum value principle applies. The maximum value of the lower level function over the unity ball is taken over the boundary which is the unity circle $\{x^2+y^2=1\}$.

\subsection{Equivalent SDP programming problem}
In this section we will derive a sdp programming equivalent of the original problem. Within this framework, we could be more likely able to remove the inverse of matrices $-n^2M+K$.  Let's cite some of the results from \cite{dumitrescu_positive_2017} that might help us.
\begin{definition}[Hermitian trigonometric polynomial]
For $(r_k)_{k=-n,\dots,n}\subset\mathbb{C}$ the function $z\in\mathbb{C}\mapsto R(z)=\sum_kr_kz^{-k}\in\mathbb{C}$ is a Hermitian trigonometric polynomial of degree $n$ iff $r_k^*=r_{-k}$, where $(.)^*$ denotes the complex conjugate.
\end{definition}
In this way, we can notice that $R(z)$ is real for any $z$ on the complex unit cercle. In \cite{dumitrescu_positive_2017}, some interesting results are given to characterize trigonometric polynomial that is non negative over the complex unit circle. We cite here one of them which is used after to derive a SDP programming-styled equivalence of the minimizing peak power problem.

Let $R$ be a trigonometric polynomial of degree $2n$, we introduce the basis vector of length $2n+1$:
$$
\chi(\omega) = \begin{bmatrix}
    1 & \cos(\omega) & \sin(\omega) & \dots & \cos(n\omega)& \sin(n\omega)
\end{bmatrix}^T
$$
Using the identity $e^{j\omega}=\cos(\omega)+\sin(\omega)j$ and trigonometric identities 
\begin{align*}
\cos(k\omega)\cos(l\omega)&=\frac{1}{2}\big(\cos(k+l)\omega+\cos(k-l)\omega\big) \\
\sin(k\omega)\sin(l\omega)&=\frac{1}{2}\big(-\cos(k+l)\omega+\cos(k-l)\omega\big) \\
\sin(k\omega)\cos(l\omega)&=\frac{1}{2}\big(\sin(k+l)\omega+\sin(k-l)\omega\big)
\end{align*}
We can prove the following Gram matrix representation theorem of non negative Hermitian trigonometric polynomial $R$:
\begin{theorem}[Gram matrix representation]
For a Hermitian trigonometrix polynomial $R$ of degree $2n$, there exists real symmetrix matrix $Q$ such that :
\begin{align}\label{Gram thrm}
    \forall \omega\in[-\pi,\pi],R(e^{j\omega})=\chi(\omega)^TQ\chi(\omega).
\end{align}
Furthermore, the $R$ is non negative over the complex unit circle, iff there exists one $Q$ that is semi definite positive.
\end{theorem}
The matrix $Q$ is not unique and if there is one $Q$ satisfying \ref{Gram thrm} that is \textbf{not} sdp, we \textbf{don't} prove that $R$ is \textbf{not} non negative. The following theorem establish a relation between $Q$ and the coefficients of $R$.

\begin{theorem}
    There exists constant complex matrices $\Gamma_k$ such that :
    $$
     \forall k\geq 0, r_k = tr[\Gamma_k Q]
    $$
\end{theorem}
Using these results, we can annouce the main theorem that will be used to derive a sdp programming styled equivalence of the minimization of peak power problem.
\begin{theorem}[maximization of trigonometric polynomial]
    Let $R$ be a Hermitian trigonometric polynomial, the following maximization problem:
    $$
    \underset{\omega\in[-\pi,\pi]}{\max} R(e^{j\omega})
    $$
    is equivalent to minimization problem:
    $$
    \underset{\lambda}{\min}~\lambda\text{ s.t. }\lambda-R \text{ is non negative Hermitian trigonometric polynomial}
    $$
    Which is equivalent to :
    $$
    \underset{\lambda,Q}{\min}~\lambda\text{ s.t. }\left\{\begin{array}{c}
         -\lambda+tr[\Gamma_0Q]=-r_0  \\
         tr[\Gamma_kQ]=-r_k,\forall k\in\{1,\dots,2n\}\\
         Q\succeq 0
    \end{array}\right.
    $$
\end{theorem}
The original problem is converted to a SDP programming problem and can be solved efficiently.

Now we recall the original problem : 
$$
\underset{a}{\min}~\underset{t}{\max}~ f(t)^Tv(t)\text{ s.t. }\left\{\begin{array}{c}
     a\geq 0 \\
     a^Tq\leq m\\
\end{array}\right.
$$
and :
$$
f(t)^Tv(t)=\sum_{l=-2N}^{2N}g_{-l}(a)e^{-jlt}.
$$
Here we change the sign of the summation index $l$ to match with the notation used in \cite{dumitrescu_positive_2017} and we explicitly mark the dependance of $g_l$ with respect to $a$. Using the previous theorem of maximization, we show the original problem is equivalent to :
$$
\underset{a,\lambda,Q}{\min}~\lambda\text{ s.t. }\left\{\begin{array}{r l}
     &a \geq 0\\
     &a^Tq \leq m\\
     &\lambda-tr[\Gamma_0Q]=0\\
     &tr[\Gamma_lQ]=-g_{-l}(a),\forall l=1,\dots,2N\\
     &Q\succeq 0
\end{array}\right.
$$
The difficulty of this approach remains only in the contraints $tr[\Gamma_lQ]=-g_{-l}(a)$, the coefficients $g_{-l}$ still contain the inverse of matrices $\{-n^2M(a)+K(a)\}$. By assembling the complex numbers $c_n(f)^Tc_m(v)$ in a $(2N+1)\times(2N+1)$ matrix $\mathcal{C}$, indexed by $n,m\in\{-N,\dots,N\}$, such that $\mathcal{C}_{n,m}=c_n(f)^Tc_m(v)$, we have :
$$
\forall l\geq 1,g_{-l}=\sum_{n+m=-l}c_n(f)^Tc_m(v)=tr[\Lambda_{-l}\mathcal{C}],
$$
where $\Lambda_l$ is a matrix, indexed by $-N$ to $N$,whose entries are $0$ except for those whose indices sum to $l$. For example, $N=2$ and $l=-1$, we have:
$$
\Lambda_{-1}=\begin{blockarray}{cccccc}
    &\matindex{-2}&\matindex{-1}&\matindex{0}&\matindex{1}&\matindex{2}\\
    \begin{block}{c(ccccc)}
        \matindex{-2}&0&0&0&1&0\\
        \matindex{-1}&0&0&1&0&0\\
        \matindex{0}&0&1&0&0&0\\
        \matindex{1}&1&0&0&0&0\\
        \matindex{2}&0&0&0&0&0\\
    \end{block}
\end{blockarray}.
$$
The non zero entries of one matrix $\Lambda_l$ fill exactly one anti-diagonal. By using these notations, the difficulties are all concentrated in the matrix $\mathcal{C}$, we would expect to use some "Schur complements" arguments to find an equivalent PMI or LMI formulation.

\section{Example}
\subsection{Assumptions}
Consider the function $f$ as follows: 
$$f(t)=a_0 + a_1\cos(t)+b_1\sin(t)+a_2\cos(2t)+b_2\sin(2t),$$
where $a_i$ and $b_i$ are vectors in $\mathbb{R}^2$ and :
$$
a_0=\begin{bmatrix}
    1 \\ 5
\end{bmatrix},a_1=\begin{bmatrix}
    -3 \\ 2
\end{bmatrix},a_2=\begin{bmatrix}
    -2 \\ 4
\end{bmatrix}
$$ and :
$$
b_1 = \begin{bmatrix}
    7 \\ -4
\end{bmatrix},b_2=\begin{bmatrix}
    0 \\ 3
\end{bmatrix}.
$$
We give now the matrices $M$ and $K$: \MT{As written earlier, $M_1, M_2$ and $K_1, K_2$ must be positive definite in this case---or at least semidefinite with a positive definite subblock.}
$$M_1=\begin{bmatrix} 1 & 0 \\ 0 & 6 \end{bmatrix},M_2=\begin{bmatrix}1 & 0\\0 &2\end{bmatrix}$$
$$K_1=\begin{bmatrix} 5 & 3 \\ 3 & 6 \end{bmatrix},K_2=\begin{bmatrix}7 & -1\\-1 &4\end{bmatrix}$$
thus $M(a,b)=aM_1+bM_2$ and $K(a,b)=aK_1+bK_2$ for $a,b\ge 0$. To simplify the notation, we say $M=M(a,b)$ and $K=K(a,b)$.

The case $k=1$:$$
K-M = \begin{bmatrix}
    4a+6b & 3a-b\\
     3a-b&6b
\end{bmatrix}$$
Which implies : 
$$
(K-M)^{-1}=\frac{\begin{bmatrix}
     6b& -3a+b\\
     -3a+b&4a+6b
\end{bmatrix}}{-9a^2 + 30ab + 35b^2}
$$
$k=2$:$$
K-4M = \begin{bmatrix}
    a+3b & 3a-b\\
     3a-b&-18a+3b
\end{bmatrix}$$
Which implies:
$$
(K-4M)^{-1} = \frac{\begin{bmatrix}
     -18a+3b& -3a+b\\
     -3a+b& a+3b
\end{bmatrix}}{-27a^2 - 45ab + 8b^2}$$

We can compute $V(t)$ as :
\begin{align}
    \begin{split}
    V(t)=&(K-M)^{-1}\left(b_1\cos(t)-a_1\sin(t)\right)+2(K-4M)^{-1}\left(b_2\cos(2t)-a_2\sin(2t)\right)    \\
    =&\frac{1}{-9a^2 + 30ab + 35b^2}\left(\begin{bmatrix}
        12a+38b\\-37a-14b
    \end{bmatrix}\cos(t)-\begin{bmatrix}
        -6a-16b\\17a+9b
    \end{bmatrix}\sin(t)\right) + \\
    &\frac{2}{-27a^2 - 45ab + 8b^2}\left(\begin{bmatrix}
        -9a+3b\\3a+9b
    \end{bmatrix}\cos(2t)-\begin{bmatrix}
        24a-2b\\10a+10b
    \end{bmatrix}\sin(2t)\right).
    \end{split}
\end{align}
Finally, since the computation is very tedious, we use the symbolic computation package \texttt{sympy} to derive that : 
\begin{align}
    \begin{split}
        f(t)^TV(t)=& \frac{6a + 200b}{9a^2 - 30ab - 35b^2}\cos^2(t)+ \\
        & \frac{-28a - 356b}{9a^2 - 30ab - 35b^2}\cos(t)\sin(t) + \\
        & \left(\frac{-52a+216b}{9a^2 - 30ab - 35b^2}+\frac{-102a-54b}{27a^2 + 45ab - 8b^2}\right)\cos(t)\cos(2t) + \\
        & \left(\frac{-63a+93b}{9a^2 - 30ab - 35b^2}+\frac{160a+136b}{27a^2 + 45ab - 8b^2}\right)\cos(t)\sin(2t) + \\
        &\frac{-121a + 109b}{9a^2 - 30ab - 35b^2}\cos(t)+\\
        & \frac{-6a - 200b}{9a^2 - 30ab - 35b^2}\sin^2(t) + \\
        & \left(\frac{-24a+100b}{9a^2 - 30ab - 35b^2}+\frac{222a+100b}{27a^2 + 45ab - 8b^2}\right)\sin(t)\cos(2t) + \\
        & \left(\frac{-27a+45b}{9a^2 - 30ab - 35b^2}+\frac{-344a-288b}{27a^2 + 45ab - 8b^2}\right)\sin(t)\sin(2t) + \\
        &\frac{-51a + 55b}{9a^2 - 30ab - 35b^2}\sin(t)+\\
        & \frac{-132a - 132b}{27a^2 + 45ab - 8b^2}\cos^2(2t) + \\
        & \frac{152a + 100b}{27a^2 + 45ab - 8b^2}\cos(2t)\sin(2t) + \\
        &\frac{-102a - 186b}{27a^2 + 45ab - 8b^2}\cos(2t)+\\
        &\frac{132a + 132b}{27a^2 + 45ab - 8b^2}\sin^2(2t)+\\
        &\frac{196a + 204b}{27a^2 + 45ab - 8b^2}\sin(2t)
    \end{split}
\end{align}
We would indeed expect $10$ "second ordered" terms by factorizing with respect to trigonometric functions. If we regard them as independant polynomial variables, the dimension of the space of polynomials with $4$ variables and of degree $2$ is $\left(\begin{array}{c}4+2\\2\end{array}\right)-\left(\begin{array}{c}4+1\\1\end{array}\right)=10$. In addition, we would expect $4$ "first order" terms coming from multiplying the constant vector $a_0$ with $V(t)$.

Now we can replace $\cos(t)$ and $\sin(t)$ by $x$ and $y$ and use trigonometric equalities to replace $\cos(2t)$ and $\sin(2t)$. As we have seen in the section \ref{laplace eqn}, the constraint of the lower level problem can be set to be $x^2+y^2\leq 1$. By denoting $G(a,b,x,y)=f(t)^Tv(t)$, we can state the bilevel optimization problem related to the assumptions : 
\begin{align}\label{eq:mainproblem}
    \underset{a,b,x,y}{\min}~ G(a,b,x,y)\text{ s.t. }\left\{\begin{array}{c}
    a,b\ge0\\
    aq_1+bq_2\le m\\
    (x,y)\in\underset{u,v}{\argmax}\{G(a,b,u,v),u^2+v^2\leq 1\}
\end{array}\right..
\end{align}
Where $q_1,q_2$, and $m$ are some positive input parameters, that control the maximum weight of the structure.

We should introduce additional constraints to eliminate fractions in the lower-level problem. We could observe that only two bivariate polynomials (as well as their product) serve as denominators in the lower-level problem, thus, we can introduce $p(9a^2 - 30ab - 35b^2)=1$ and $q(27a^2 + 45ab - 8b^2)=1$. The lower-level problem becomes :
$$
\forall(a,b,p,q), (x,y)\in\underset{u,v}{\argmax}~G(a,b,p,q,u,v)\text{ s.t. }\left\{\begin{array}{c}
    u^2+v^2\leq 1\\
    p(9a^2 - 30ab - 35b^2)=1 \\
    q(27a^2 + 45ab - 8b^2)=1 \\
\end{array}\right.
$$
\textcolor{green}{Shen : }Note that we do not need as many additional variables as Saman shows in the previous sections to eliminate fractions. In fact, only $N$ additional variables are needed if $f$ is a sum of $N$ harmonics. Moreover, let $p_k$ be the kth variable introduced to eliminate fractions, and the associated constraint is indeed $p_k(-\det(K(a)-k^2M(a)))=1$. If one set these equality constraints, one can also eliminate the constraints $\det(K(a)-k^2M(a))\neq 0$.

\begin{remark}[shen]
The feasible set is compact? (assumptions to apply sos hierarchy ?) Can the equalities constraints of $p$ and $q$ fail the compacity? \textcolor{green}{Please see comments in Section 4.}
\end{remark}

\begin{remark}[shen]
    The computation is tedious due to the unhandy explicit inversion of matrices. Can we be inspired by \cite{tyburec_global_2021} proposition 1? Where we use pseudo inverse but is converted to PMI using Schur complement. Maybe difficult if we don't assume sdp-ness of $K(a)-k^2M(a)$ since $k$ can be large ($f$ with high frequency). Marek shows that this is related to the intended design of the structure such that the smallest resonance frequency is large enough for the load.
\end{remark}
\MT{Yes, that's because $K-k^2 M\succeq 0$ is equivalent to requiring that the eigenvalues of the generalized eigenvalue problem $Ku - \lambda M u = 0$ are greater than or equal to $k^2$.}

\begin{remark}[shen]
    In \cite{jeyakumar_convergent_2016} remark 4.9, we generalize the bilevel approach, allowing constraints of type $h(x,w)\leq 0$ in the lower level problem, the generalization holds when the solution of the lower level problem is continuous with respect to $x$. While as we see by previous computations, we are in the degenerated case where $h(x,w)=h(x)$. The optimization variables $u,v$ are not involved in the equalities constraints. We can move them into the higher level problem. 
\end{remark}

Finally, the bilevel problem to solve is :
\begin{align}\label{bilevel-example}
\underset{a,b,p,q,x,y}{\min}~ G(a,b,x,y,p,q)\text{ s.t. }\left\{\begin{array}{c}
    a,b\ge0\\
    aq_1+bq_2\le m\\
    p(9a^2 - 30ab - 35b^2)=1 \\
    q(27a^2 + 45ab - 8b^2)=1 \\
    (x,y)\in\underset{u,v}{\argmax}\{G(a,b,p,q,u,v),u^2+v^2\leq 1\}
\end{array}\right.,
\end{align}
where $G(a,b,p,q,x,y)$ reads:
$$
G(a,b,p,q,x,y)=\begin{array}{r l}
      &(6a + 200b)px^2+ \\
      &   (-28a - 356b)pxy + \\
      &   ((-52a+216b)p+(-102a-54b)q)x(x^2-y^2) + \\
      &   2((-63a+93b)p+(160a+136b)q)x^2y + \\
      & (-121a + 109b)px+\\
      &   (-6a - 200b)py^2+ \\
      &   ((-24a+100b)p+(222a+100b)q)y(x^2-y^2) + \\
      &   2((-27a+45b)p+(-344a-288b)q)xy^2 + \\
      &  (-51a + 55b)py+\\
       &  (-132a - 132b)q(x^2-y^2)^2 + \\
       &  2(152a + 100b)q(x^2-y^2)xy + \\
       & (-102a - 186b)q(x^2-y^2)+\\
      &  4(132a + 132b)qx^2y^2+\\
      &  2(196a + 204b)qxy
\end{array}
$$

\subsection{Convert bilevel problem to single level}
The problem \ref{bilevel-example} is a special case of the Bilevel POP presented in \cite{jeyakumar_convergent_2016}. The objective function and the lower-level problem coincide which makes it into a min-max problem. We could introduce another additional variable $\lambda$ such that :
\begin{align}
\underset{\begin{array}{c}
     a,b,p,q,x,y  \\
     \lambda 
\end{array}}{\min}~ \lambda \text{ s.t. }\left\{\begin{array}{c}
    a,b\ge0\\
    aq_1+bq_2\le m\\
    p(9a^2 - 30ab - 35b^2)=1 \\
    q(27a^2 + 45ab - 8b^2)=1 \\
    x^2+y^2\leq 1\\
    \lambda\geq G(a,b,p,q,x,y)
\end{array}\right.
\end{align}
is equivalent to the original problem.

\textcolor{blue}{Arash:} As a general matter of notation, built on \cite{jeyakumar_convergent_2016} one can also write the problem \ref{eq:mainproblem} by analogy with 
\begin{align*}
 &{\rm min }_{a,b,x,y} G(a,b,x,y) \\\\& 
 {\rm subject ~to}~ g_1(a,b) = aq_1+ bq_2-m\le 0\\\\& 
 (x,y) \in Y(a,b) = \mathop {\rm argmax} \limits_{{u^2} + {v^2} \le 1} G(a,b,u,v) 
\end{align*}
Now, we can consider $K=\{(a,b):  g_1(a,b)\le0\}$ and $F=\{(u,v):  h(u,v)=u^2+v^2-1\le0\}$
It is worthwhile to note that $Y$ and $g_1$ are continuous and convex. The feasible set is $\mathcal{C}=\{(a,b,x,y):~~g_1(a,b)\le0~ (x,y)\in Y(a,b)\}$, taking into consideration that the blanket assumption $\mathcal{C}\ne\emptyset$ we will have the feasible set is closed and convex but not compact due to the lack of boundedness.   
One may use the following auxiliary Lemma:
\begin{lemma}
 Let $C$ be a nonempty convex and $f_i$ be convex real function, then there exist $\alpha_i\ge0$ such that $\sum_{i}\alpha_i=1$ and \[\mathop {\inf }\limits_C \mathop {\max }\limits_{1 \le i \le m} {f_i} = \mathop {\inf }\limits_C (\sum\limits_i {{\alpha _i}{f_i}} )\]
\end{lemma}

\subsection{Implementation using \texttt{ncpol2sdpa}}
\texttt{ncpol2sdpa} is built using \texttt{sympy} which allows us to build the objective function and constraints efficiently using symbolic computation. 

\include{output_example.tex}
\MT{From my experience, SDPA sometimes struggles with numerical issues when solving structural optimization problems. I have played with the solver parameters approx. five years ago, maybe I can find the improved ones. Also, SDPA is by-default slow. It can be accelerated considerably by linking against Intel MKL (then the speed is comparable to MOSEK). Yet, Mosek is much more robust from my experience.}

\section{Saman's comments}
\textcolor{green}{About the comments of Arash (blue)}: None of the terms "convex," "concave," "smooth," and "continuous" were mentioned in Theorem 4.7. Only in the case of continuity is it necessary to prove the continuity of the lower level optimization problem on the solution space of the constraints of the upper level optimization problem. This is necessary because we want to use the generalization of Theorem 4.7 and this continuity must be verified according to the conditions mentioned in Remark 4.9. It is done in Remark 1.2. However, as for the fact that you proved that there is no minimizer at all and it is not a well-defined problem:
\begin{itemize}
	\item[\it (i)]
Your proof seems to be correct.

	\item[\it (ii)]
I wrote a long discussion on this topic yesterday. However, I saw that $a$ and $b$ were considered greater than zero in the comments in section 3 ($a,b\geq0$ and also $q_1, q_2 \geq 0$). So the case is closed now.
	\item[\it (iii)]
The point that comes out of this discussion is that sometimes examining the problem on the lines can help clarify the theory and the calculations because the theory and the calculation on the lines are much simpler. This may come in handy later.
	.
\end{itemize}
\textcolor{green}{About the comments of Shenyuan}: Regarding the discussion you have had about the interior of the set $E=\lbrace (x,y) \in \mathbb{R}^2\vert ~x^2+y^2=1\rbrace$, I should say that this problem also exists for the constraints of $Q_{i,k,j}(a_1,a_2,\dots,a_r)-P_{i,k,j}(a_1,a_2,\dots,a_r)e_{i,k,j}=0$. If we want to speak on the basis of the assumptions of the main theorem (Theorem 4.7), we should say that the assumption of $\overline{(K \cap F)^{\circ}}=K \cap F$ is damaged. Because we have $E^{\circ}=\phi$, so
$$\overline{E^{\circ}}=\overline{\phi}=\phi\neq E$$
Perhaps what you suggested (substituting $x^2+y^2 \leq1$ in place of $x^2+y^2=1$) would be really good. However, my suggestion is to replace $x^2+y^2=1$ with $\varepsilon \leq x^2+y^2-1 \leq \varepsilon$. The $\varepsilon$ can be considered the same $\varepsilon$ that was considered in step 0 of Algorithm 4.5 (page 17). We have: 
\begin{align*}
& E_\varepsilon=\lbrace (x,y) \in \mathbb{R}^2 \vert \varepsilon\leq x^2+y^2-1 \leq \varepsilon \rbrace\\
&E^\circ_\varepsilon=\lbrace (x,y) \in \mathbb{R}^2 \vert \varepsilon <x^2+y^2-1 <\varepsilon \rbrace\\
&\overline{E^\circ_\varepsilon}=\lbrace (x,y) \in \mathbb{R}^2 \vert \varepsilon \leq x^2+y^2-1 \leq \varepsilon \rbrace= E_\varepsilon 
\end{align*}
Thus, with this technique, the assumption of $\overline{(K \cap F)^{\circ}}=K \cap F$ is satisfied. By this technique, we also change the form of the constraints to the format desired in Lasserre’s paper; namely, we replace $x^2+y^2 =1$ with the following constraints:
\begin{align*}
& ~~~~x^2+y^2-1-\varepsilon \leq 0\\
&-x^2-y^2+1-\varepsilon \leq 0
\end{align*}
In addition to the above discussion, there is a similar problem but in a different way for unequal constraints($P_{i,k,j}(a_1,a_2,\dots,a_r)\neq 0$). If $E=\lbrace (a_1,\dots,a_r) \in \mathbb{R}^r \vert P_{i,k,j}(a_1,a_2,\dots,a_r)\neq 0\rbrace$, then
$$\overline{E^\circ}=\overline{E}=\mathbb{R}^r\neq E$$
To fix this, we replace $P_{i,k,j}(a_1,a_2,\dots,a_r)\neq 0$ with $P_{i,k,j}(a_1,a_2,\dots,a_r) \not\in(-\varepsilon,\varepsilon)$. But instead of turning one constraint into two constraints, we turn one Bilevel POP into two Bilevel POP. One by considering the constraint of $P_{i,k,j}(a_1,a_2,\dots,a_r) \leq -\varepsilon$ and the other by considering the constraint of $P_{i,k,j}(a_1,a_2,\dots,a_r) \geq \varepsilon$. Then we compare the solutions of these two Bilevel POP. In general, if we have $n$ unequal constraints, $\frac{n!}{2! (n-2)!}$ separate Bilevel POP must be solved, and their solutions are then compared to find the best solution.
In the following, we explain the approach described above with a simple example. 
\textcolor{green}{Shen:}  the number of separated bilevel pop is $2^n$.\textcolor{green}{Saman:}Thank you, Shen. You are right. Also, from what you mentioned, we have something like this: 
$$P_{i,k,j}(a_1,a_2,\dots,a_r)=det(K(a)-k^2M(a));~i,j \in \lbrace 1,2 \rbrace, 1\leq k\leq N$$
So our main bilevel optimization problem is as follows:
\begin{align*}
 &{\text{minimize}}_{(a_1,\dots,a_r)\in {\mathbb{R}}^r} C(a_1,\dots,a_r)\\
&~~~~~~~~~~q_1a_1+\cdots+ q_ra_r \leq m\\
s.t~~&C(a_1,\dots,a_r)=\text{Max}_{x \in [-1,1],~y \in [-1,1],~e_{i,k,j} \in {\mathbb{R}}}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j}R_{i,k,j}(x,y)\\
&~~~~~~~~~~Q_{i,k,j}(a_1,a_2,\dots,a_r)-P_{i,k,j}(a_1,a_2,\dots,a_r)e_{i,k,j}=0;~i,j \in \lbrace 1,2 \rbrace, 1\leq k \leq N,\\
&~~~~~~~~~~P_{i,k,j}(a_1,a_2,\dots,a_r)\neq 0;~i,j \in \lbrace 1,2 \rbrace, 1 \leq k\leq N,\\
&~~~~~~~~~~x^2+y^2=1.
\end{align*}
Moreover, if we make your assumption that $Q_{i,k,j}(a_1,a_2,\dots,a_r)-P_{i,k,j}(a_1,a_2,\dots,a_r)e_{i,k,j}=0$ satisfies $P_{i,k,j}(a_1,a_2,\dots,a_r)\neq 0$, then the main problem would have the following format: 
\begin{align*}
 &{\text{minimize}}_{(a_1,\dots,a_r)\in {\mathbb{R}}^r} C(a_1,\dots,a_r)\\
&~~~~~~~~~~q_1a_1+\cdots+ q_ra_r \leq m\\
s.t~~&C(a_1,\dots,a_r)=\text{Max}_{x \in [-1,1],~y \in [-1,1],~e_{i,k,j} \in {\mathbb{R}}}\sum_{j=1}^{2}\sum_{i=1}^{2}\sum_{k=1}^{N}e_{i,k,j}R_{i,k,j}(x,y)\\
&~~~~~~~~~~Q_{i,k,j}(a_1,a_2,\dots,a_r)-P_{i,k,j}(a_1,a_2,\dots,a_r)e_{i,k,j}=0;~i,j \in \lbrace 1,2 \rbrace, 1\leq k\leq N,\\
&~~~~~~~~~~x^2+y^2=1.
\end{align*}
In fact, this makes all unequal constraints unnecessary, and so does all discussion of unequal constraints (including the $\varepsilon$ method). However, if our new idea of approximating the objective function by polynomials really works and we want to continue on this basis, then the $\varepsilon$-method (presented above) will be needed again because in the idea, explained in subsection 4.5, the constraint $det(K(a)-k^2M(a))$ should come back by the absence of $Q_{i,k,j}(a_1,a_2,\dots,a_r)-P_{i,k,j}(a_1,a_2,\dots,a_r)e_{i,k,j}=0$ in constraints.
\textcolor{green}{shen : we can put the equality constraints $e_{i,k,j}P_{i,k,j}(a)=1$ and keep $Q_{i,k,j}$ in the expression of the objective funciton. By doing so we remove the unequal constraints and the objective function is still a polynomial.}
\subsection{Example}
$M(a,b)=a+b,~K(a,b)=2a+3b,~q_1=5,~q_2=7,~m=12,~f(t)=3-\sin t+4\cos t+2\sin 2t-\cos 2t$

By using the relation between $f$ and $v$, we find :
$$
v(t)=\frac{1}{2a+b}(-\cos(t)-4\sin(t))+\frac{2}{-2a-b}(2\cos(2t)+\sin(2t)).
$$
so we can compute :
$$
f(t)v(t)= \frac{1}{a+2b}R(\cos(t),\sin(t))+\frac{2}{-2a-b}S(\cos(t),\sin(t)),
$$
where $R$ and $S$ are bivariate polynomials such that :
$$
    R(\cos(t),\sin(t))=\begin{array}{c}
        -15\sin(t)-\frac{13}{2}\cos(t)\\
        -\frac{15}{2}\sin(2t)-4\cos(2t)\\
        +\sin(3t)+\frac{9}{2}\cos(3t)\\
    \end{array}~
    S(\cos(t),\sin(t))=\begin{array}{c}
        3\sin(t)+\frac{7}{2}\cos(t)\\
        3\sin(2t)+6\cos(2t)\\
        +3\sin(3t)+\frac{9}{2}\cos(3t)\\
        -2\cos(4t)
    \end{array}.
$$
We can check handily that $\int_0^{2\pi} f(t)v(t)\mathrm{d}t=0$ for all $(a,b)$, which confirms with the computation made in the section \ref{shenyuan 1}.

The original minimization problem is :
$$
\underset{a,b,x,y}{\min}~ \frac{1}{a+2b}R(x,y)+\frac{2}{-2a-b}S(x,y)\text{ s.t. }\left\{\begin{array}{c}
    a\geq0,b\geq0,5a+7b\leq12   \\
    (x,y)\in\argmax\{\frac{1}{a+2b}R(u,v)+\frac{2}{-2a-b}S(u,v), u^2+v^2-1\leq1\}
\end{array}\right.
$$
We introduce supplementary variables $p,q$ to replace fractions : 
\begin{align*}
    \begin{array}{cc}
        \underset{a,b,p,q,x,y}{\min} &  pR(x,y)+qS(x,y)\\
         \text{ s.t. }& \left\{\begin{array}{c}
             a\geq0,b\geq0,5a+7b\leq12   \\
             p(a+2b)=1,q(-2a-b)=2 \\
    (x,y)\in\argmax\{pR(u,v)+qS(u,v), u^2+v^2-1\leq0\}
         \end{array}\right.
    \end{array}
\end{align*}
\textcolor{blue}{Shen, Arash} we put the previous bilevel problem into the form presented in \cite{jeyakumar_convergent_2016} : 
\begin{align*}
    \begin{array}{cc}
        \underset{(a,b,p,q),(x,y)}{\min} & f((a,b,p,q),(x,y))= pR(x,y)+qS(x,y)\\
         \text{ s.t. }& \left\{\begin{array}{c}
             g_1((a,b,p,q),(x,y))=-a\leq0 \\
             g_2((a,b,p,q),(x,y))=-b\leq0 \\
             g_3((a,b,p,q),(x,y))=5a+7b-12\leq0 \\
             g_4((a,b,p,q),(x,y))=p(a+2b)-1\leq0 \\
             g_5((a,b,p,q),(x,y))=1-p(a+2b)\leq0 \\
             g_6((a,b,p,q),(x,y))=q(-2a-b)-2\leq0 \\
             g_7((a,b,p,q),(x,y))=2-q(-2a-b)\leq0 \\
    (x,y)\in Y(a,b,p,q)=\underset{u,v}{\argmin}\{G((a,b,p,q),(u,v))=-pR(u,v)-qS(u,v),\\ h_1(u,v)=u^2+v^2-1\leq0\}
         \end{array}\right.
    \end{array}
\end{align*}

\subsection{Theoretical discussions about the existence of the solution}
\subsubsection{Enforcing the compacity of the feasible set}\label{example1d:compacity}

The feasible set is not compact due to the equality constraints $p(a+2b)=1$ and $q(-2a-b)=2$. As a consequence of those equality constraints, $p$ and $q$ are not bounded if $a,b$ are small enough. We need to add bounds to $p$ and $q$ so that the feasible set becomes compact without changing the solution.

We can first verify that using the constraints $a\geq 0,b\geq 0,5a+7b\leq 12$, we can deduce that $a\leq\frac{12}{5}$ and $b\leq\frac{12}{7}$, which imply the bounds $p\geq\frac{35}{204}$ and $q\leq-\frac{70}{228}$ for any feasible $p$ and $q$.

Furthermore, let's assume that $(a^*,b^*,p^*,q^*,x^*,y^*)$ is indeed a global solution of the previous optimization problem, then necessarily for any fixed feasible point $(a_0,b_0,p_0,q_0,x_0,y_0)$ and $(u,v)$ such that $u^2+v^2=1$, we have :
$$
p_0R(x_0,y_0)+q_0S(x_0,y_0)\geq p^*R(x^*,y^*)+q^*S(x^*,y^*)\geq p^*R(u,v)+q^*S(u,v).
$$
The first inequality holds because $(a^*,b^*,p^*,q^*,x^*,y^*)$ is a global solution of the Bilevel problem while the second inequality holds because $(x^*,y^*)$ is the solution of the lower level problem at given $(a^*,b^*,p^*,q^*)$. 

Now note that for $$
u_0=\cos(\frac{11\pi}{6}),v_0=\sin(\frac{11\pi}{6})\implies R(u_0,v_0)\approx 5.366, S(u_0,v_0)\approx -0.067
$$ and $$
M > \min\{\frac{35}{204}R(u_0,v_0)+\frac{-70}{228}S(u_0,v_0), p_0R(x_0,y_0)+q_0S(x_0,y_0)\},
$$
then :
$$
(p^*,q^*)\in\mathcal{P}=\{(p,q)\in\mathbb{R}^2,p\geq \frac{35}{204},q\leq\frac{-70}{228},pR(u_0,v_0)+qS(u_0,v_0)\leq M\},
$$
which is a bounded set independant of the solution $(a^*,b^*,p^*,q^*,x^*,y^*)$.

We have thus proven that if $(a^*,b^*,p^*,q^*,x^*,y^*)$ is a global solution of the Bilevel problem, necessarily, it satisfies:
$$
(a^*,b^*),(p^*,q^*),(x^*,y^*)\in\{a\geq 0, b\geq 0, 5a+7b-12\leq 0\} \times \mathcal{P}\times\{u^2+v^2 - 1\leq 0\},
$$
which is a compact set. We can thus add the constraint $$pR(u_0,v_0)+qS(u_0,v_0)-M\leq 0$$ 
to restrict the feasible set to a compact set.

\textcolor{green}{Shen : The idea is to restrict the solution to a compact set by assuming its existence. The compact set that we eventually derived from the assumed solution should be indepedant of it. Later on, when we will actually solve it, we will only need to look inside the compact set since there will not be solution outside. This trick is used in \cite{tyburec_global_2021} as well.}

\textcolor{green}{Combined with the discussion of the next subsubsection, we can actually prove the existence of solution using Theorem 4.7 of \cite{jeyakumar_convergent_2016}.
}

\subsubsection{$\overline{(K \cap F)^{\circ}}=K \cap F$}
\textcolor{green}{Saman}: 
First, we define the sets of $E_1, E_2, E_3, E_4, E_5, E_6, E_7, F$ as follows:
\begin{align*}
& E_1=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert -a\leq0 \rbrace\\
&E_2=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert -b\leq0 \rbrace\\
&E_3=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert 5a+7b-12\leq0 \rbrace\\
&E_4=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert p(a+2b)-1\leq0 \rbrace\\
&E_5=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert 1-p(a+2b)\leq0 \rbrace\\
&E_6=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert q(-2a-b)-2\leq0 \rbrace\\
&E_7=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert 2-q(-2a-b)\leq0 \rbrace\\
&F=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert x^2+y^2-1\leq0 \rbrace 
\end{align*}
We have $(E_4 \cap E_5)^{\circ}=\phi$, $(E_6 \cap E_7)^{\circ}=\phi$, then
\begin{align*}
\overline{(K \cap  F)^{\circ}}&=\overline{{E_1}^\circ \cap {E_2}^\circ \cap {E_3}^\circ \cap {{(E_4 \cap E_5)}^\circ} \cap {{(E_6 \cap E_7)}^\circ} \cap F^{\circ}}\\
&=\overline{\phi}=\phi \neq K \cap F.
\end{align*}
But if we exchange the sets $E_4, E_5, E_6, E_7$ with the sets $E_{4,\varepsilon}, E_{5,\varepsilon}, E_{6,\varepsilon}, E_{7,\varepsilon}$, equality is established:
\begin{align*}
&E_{4,\varepsilon}=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert p(a+2b)-1-\varepsilon\leq0 \rbrace\\
&E_{5,\varepsilon}=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert 1-p(a+2b)-\varepsilon\leq0 \rbrace\\
&E_{6,\varepsilon}=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert q(-2a-b)-2-\varepsilon\leq0 \rbrace\\
&E_{7,\varepsilon}=\lbrace (a,b,p,q,x,y) \in \mathbb{R}^6 \vert 2-q(-2a-b)-\varepsilon\leq0 \rbrace. 
\end{align*}
Now suppose the set $K_{\varepsilon}$ is as follows:
$$K_{\varepsilon}={E_1}  \cap {E_2}  \cap {E_3} \cap {E_{4,\varepsilon}} \cap {E_{5,\varepsilon}} \cap {E_{6,\varepsilon}} \cap {E_{7,\varepsilon}}$$
and also suppose $(a_\varepsilon^*,b_\varepsilon^*,p_\varepsilon^*,q_\varepsilon^*,x_\varepsilon^*,y_\varepsilon^*)$ is a solution of the following bi-level problem:

\begin{align*}
        \underset{(a,b,p,q),(x,y)}{\min} & f((a,b,p,q),(x,y))= pR(x,y)+qS(x,y)\\
         \text{ s.t. }& \left\{\begin{array}{c}
             (a,b,p,q,x,y) \in K_{\varepsilon} \\
    (x,y)\in Y(a,b,p,q)=\underset{u,v}{\argmin}\{G((a,b,p,q),(u,v))=-pR(u,v)-qS(u,v),\\ (a,b,p,q,u,v) \in F\}
         \end{array}\right.
\end{align*}
\textcolor{blue}{Arash: This following part should be rectified, it is not correct: To better make it out, ponder: $f(x)=\frac{1}{1+x^2}$ and $C=[-1,1]$ and $C_{\epsilon}=[\epsilon-1,1+\epsilon]$ we have $C=\cap_{\epsilon>0}[\epsilon-1,1+\epsilon]$, one can readily see that $x^*=-1$ is optimal point of $f$ over $C$ and $x^*_{\epsilon}=1-\epsilon$ are optimal points of $f$ over $C_{\epsilon}$ constraint, while \[|x^*_{\epsilon}-x^*|\to 2\ne0\]}%
\textcolor{magenta}{Michal Kocvara: This may not be a good counter example: The original problem with $C$ has two global solutions $x^*=1$ and $x^{**}=-1$. Moreover, the $\epsilon$ relaxation should be symmetric, $C_\epsilon = [-1+\epsilon,1+\epsilon]$, then the solutions of the relaxed problem will, again, be non-unique. But it will satisfy the theorem: There is a subsequence of the solutions $x^*_\epsilon$ of the relaxed problem converging to a (one of the) solution of the original problem.}
\textcolor{blue}{Arash: Sounds right, but we know nothing about uniquness of optimal points of objective function}

It only remains to show:
$$\Vert(a_\varepsilon^*,b_\varepsilon^*,p_\varepsilon^*,q_\varepsilon^*,x_\varepsilon^*,y_\varepsilon^*)-
(a^*,b^*,p^*,q^*,x^*,y^*)\Vert\longrightarrow 0~~\text{when}~~\varepsilon\longrightarrow 0$$
where $(a^*,b^*,p^*,q^*,x^*,y^*)$ is a solution of the main problem. In other words, we need to ensure that the sequence of $\lbrace(a_{1/n}^*,b_{1/n}^*,p_{1/n}^*,q_{1/n}^*,x_{1/n}^*,y_{1/n}^*)\rbrace_{n \in \mathbb{N}}$ does not behave badly when $n$ tends to infinity, for example, the sequence of $\lbrace\Vert(a_{1/n}^*,b_{1/n}^*,p_{1/n}^*,q_{1/n}^*,x_{1/n}^*,y_{1/n}^*)\Vert \rbrace_{n \in \mathbb{N}}$ does not tend to infinity when $n$ tends to infinity. \textcolor{green}{a discussion}: It seems that if the problem is well-defined, this bad behavior does not occur at all. To illustrate, suppose the $P(x,y)$ is a polynomial. Since $P(x,y)$ is continuous, the following optimization problems should have very similar solutions.
\begin{align*}
 &{\text{minimize}}_{(x,y)\in {\mathbb{R}}^2} P(x,y)\\
&~~~~~~~~~~x^2+y^2-1=0\\
\end{align*}
\begin{align*}
 &{\text{minimize}}_{(x,y)\in {\mathbb{R}}^2} P(x,y)\\
&~~~~~~~~~~-0.00001 \leq x^2+y^2-1\leq 0.00001
\end{align*}
However, the problem is that we have fractions here. According to Shen and Arash, there is no problem with fractions. This is because, in their opinion, the roots of fractions and their surroundings are not in the feasible region. However, it should be mentioned that if the sequences of $\{\Vert(a_{1/n}^*,b_{1/n}^*,p_{1/n}^*,q_{1/n}^*,x_{1/n}^*,y_{1/n}^*)\Vert \}_{n \in \mathbb{N}}$ were infinite, the problem is that the optimization problem is not well-defined, and this is indeed not up to us, but to our friends from structural engineering in defining the optimization problem.\textcolor{green}{Saman to Shen}: Please do the numerical tasks using the method described above by selecting different $\varepsilon$. This has two advantages. First, based on the theory, we have proved the existence of the solution to the problem for each $\varepsilon$. Second, by selecting different $\varepsilon$($\varepsilon=1, \varepsilon=0.1, \varepsilon=0.01, \varepsilon=0.001, ...$), we can check the convergence of the sequence of $(a_\varepsilon^*,b_\varepsilon^*,p_\varepsilon^*,q_\varepsilon^*,x_\varepsilon^*,y_\varepsilon^*)$.

\textcolor{blue}{Arash:  The following discussion is also incorrect: For instance take simple example $f(x)=1$ over constraint $C_{\epsilon}=[\epsilon,\infty)$, right there and then we will have $x^*_{1/n}=n$ are optimal points but the set of them is not bounded}
\textcolor{green}{Shen: maybe we should prove these things :}
\begin{itemize}
    \item prove that the sequence $(a_{1/n}^*,b_{1/n}^*,p_{1/n}^*,q_{1/n}^*,x_{1/n}^*,y_{1/n}^*)$ is bounded. So we can extract a converging sub sequence.
    \item prove that the sequence of the optimal value $(f(a_{1/n}^*,b_{1/n}^*,p_{1/n}^*,q_{1/n}^*,x_{1/n}^*,y_{1/n}^*))$ converges
    \item The sub sequence extracted in the first point converges to a global solution of the original problem, by the two previous points.
\end{itemize}
There is maybe not a unique solution to the original problem, proving the convergence of the sequence $(a_{1/n}^*,b_{1/n}^*,p_{1/n}^*,q_{1/n}^*,x_{1/n}^*,y_{1/n}^*)$ requires the unicity of the global solution to the original problem, which is not garanteed.

And we should add the constraint $g_8$ obtained in the previous subsub section and examine if it's still valid in the where equality constraints are relaxed by $\varepsilon$, by doing so, for each $\varepsilon$, $(a_\varepsilon^*,b_\varepsilon^*,p_\varepsilon^*,q_\varepsilon^*,x_\varepsilon^*,y_\varepsilon^*)$ is confined in a compact region.

\textcolor{red}{Professor Michal Kočvara recommended to add $\varepsilon$ as an optimization variable to remove the problem of non empty interior. By adding $\varepsilon$ to the objective function, $\varepsilon$ would tends to decrease and even vanish so that the new problem could give an equivalent solution as the original bilevel problem. In the previous $\varepsilon$-approximation approach, by giving a small $\varepsilon$, the added interior of the feasible set could be too small for optimization solver to proceed successfully.}

\textcolor{blue}{Arash: I think this discussion maybe wrong. Let us take $f(x)=\frac{1}{1+x^2}$ with $C=[-1,1]$ and $f_{\epsilon}(x)=\frac{1}{1+x^2}+\epsilon$ with $C_{\epsilon}=[\epsilon-1,1-\epsilon]$ then one sees that $x^*=-1$ and $x^*_{\epsilon}=1-\epsilon$ and there is nothing between $x^*_{\epsilon}$ and $x^*$.}

\textcolor{green}{Shen : You are right, I have some doubt about this approach. But your example doesn't seem to be relevant to the problem. We planed to introduce $\varepsilon$ to add interior points to the feasible set while your example already starts with non empty interior.}

We could formulate the follow minimization problem : 
\begin{align*}
    \begin{split}
    \underset{a,b,p,q,x,y,\varepsilon}{\min} & pR(x,y)+qS(x,y)+\varepsilon\\
    \text{ s.t. } & \left\{\begin{array}{c}
        a\geq 0,b\geq 0, 5a+7b\leq 12, \\
        -\varepsilon\leq p(a+2b)-1\leq \varepsilon, -\varepsilon\leq q(-2a-b)-2\leq \varepsilon,\\
        0\leq \varepsilon \leq \frac{1}{2} \\
        (x,y)\in\underset{u,v}{\argmin}\{-pR(u,v)-qS(u,v),u^2+v^2-1\leq 0\}
    \end{array}\right.
    \end{split}
\end{align*}
The upper bound of $\varepsilon$ in the constraints is given because we are only interested in the solutions given by small $\varepsilon$ and it provides compacity. Thanks to this upper bound, the discussion in \ref{example1d:compacity} still holds by taking a large enough constant $M$, independent of all variables, and by considering the same $u_0,v_0$. Finally, we will solve the following bilevel POP : 
\begin{align*}
    \begin{split}
    \underset{a,b,p,q,x,y,\varepsilon}{\min} & pR(x,y)+qS(x,y)+\varepsilon\\
    \text{ s.t. } & \left\{\begin{array}{c}
        a\geq 0,b\geq 0, 5a+7b\leq 12, \\
        -\varepsilon\leq p(a+2b)-1\leq \varepsilon, -\varepsilon\leq q(-2a-b)-2\leq \varepsilon,\\
        0\leq \varepsilon \leq \frac{1}{2}, \\
        pR(u_0,v_0)+qS(u_0,v_0)\leq M\\
        (x,y)\in\underset{u,v}{\argmin}\{-pR(u,v)-qS(u,v),u^2+v^2-1\leq 0\}
    \end{array}\right.
    \end{split}
\end{align*}

The lower level problem is not convex due to the non convexity of the objective function, by virtus of \cite{jeyakumar_convergent_2016}, for each $\delta>0$, we define the $\delta$-approximation problem : 

\begin{align*}
    \begin{split}
    \underset{a,b,p,q,x,y,\varepsilon}{\min} & pR(x,y)+qS(x,y)+\varepsilon\\
    \text{ s.t. } & \left\{\begin{array}{c}
        a\geq 0,b\geq 0, 5a+7b\leq 12, \\
        -\varepsilon\leq p(a+2b)-1\leq \varepsilon, -\varepsilon\leq q(-2a-b)-2\leq \varepsilon,\\
        0\leq \varepsilon \leq \frac{1}{2}, \\
        pR(u_0,v_0)+qS(u_0,v_0)\leq M,\\
        G((a,b,p,q),(x,y))-\underset{u,v}{\min}\{G((a,b,p,q),(u,v)), u^2+v^2-1\leq 0\}\leq \delta
    \end{array}\right.
    \end{split}
\end{align*}

Since the upper and lower feasible set of the original problem are compact, the solutions of $\delta$-approximation problems are bounded and we can extract a converging sequence to the global solution of the original problem letting $\delta$ tend to $0$. For each $\delta$, the lower level problem requires to solve for a parametric POP. This can be done by computing a degree $k$ polynomial approximation (see \cite{lasserre_jointmarginal_2010}). The Lemma 4.1 and Theorem 4.7 of \cite{jeyakumar_convergent_2016} combined are available to prove the convergence of $(\delta,k)$-solution to a global solution of the original problem, here $(\delta,k)$-solution means the solution to the original problem where the lower level problem is relaxed by $\delta$ and the resulting parametric POP is approximated by degree $k$. This convergence result requires non-empty interior for the feasible set of both the upper and lower level problem, this is provided by adding $\varepsilon$.

Regarding the original problem, the compacity of feasible sets garantees the existence of solution, but the condition of non-empty interior failed due to the equality contraints. It is not clear that the convergence results of the . We can note that the two problems are equivalent if, in the solution of the later problem, $\varepsilon$ vanishes.

\subsection{Numerical tasks 1 (Lasserre's Algorithm)}
\subsection{Numerical tasks 2 (single-level POP by Shenyuan)}
\subsection{Further discussions}
\textcolor{green}{A question}: Does it matter after what time the computer gives us the output of the program?
Does it make a difference to us whether it outputs after 20 minutes or after 2 hours, for example?
\MT{From my point of view, the faster the better. Yet, there is indeed a price for global optimality, which would be understood by the readers.}

\textcolor{red}{Arash,Saman,Shen}:
One sees, just in case we would be able to find a sequence of uniformly converging polynomials $P_n$ to the objective function $g$, then there should be a nice approximation for the objective function that works in its place. In this case, all discussion of constraints and so on can be dropped. We rely on a main theorem of mathematical analysis that allows us to do this, provided the objective function is continuous. Even if the objective function is not continuous over zeros, this does not seem to be a serious problem. For example, even if the function $1/x$ is not continuous on $[-1,1]$, there is still a sequence of polynomials that converge to it. In this case, the ${\rm Max Min}$ of the polynomials would be convergent to the ${\rm Max Min}$ of the objective functions. Also, we have recently understood that we should have $|f(t)^Tv(t)|$ instead of $f(t)^Tv(t)$. This new proposal solves this problem as well.

\section{Ideals}
\subsection{Improve scalabilty}
In our discussion, so far, we rely on the inverse of the matrices $-k^2M(a)+K(a)$ to express the objective function. This may have those problems :
\begin{itemize}
    \item they introduce large degree polynomials. Typically, if $f$ is $d$ dimensional, the inverse of the matrices $-k^2M(a)+K(a)$ introduce polynomial of degree $d$. 
    \item It's not garanteed to have those inverses for larger scale problem, even if it's possible, it would be necessary to exploit sparsity.
    \item $-k^2M(a)+K(a)$ could be singular for more general case, as discussed in \cite{tyburec_global_2021}. Again, calculating explicitly the pseudo inverse could be impossible due to the scale of the problem.
\end{itemize}

We might be able to improve our method by using Schur's complement, since it converts some types of expression that involves inverse of matrices into LMI or PMI. Let $M\succeq 0$ with pseudo inverse $M^\dagger$ and let $f$ be a vector in the range of $M$. Then the quadratic form $f\mapsto f^TM^{\dagger}f$ can be seen as the solution of the minimization problem :
$$
f^TM^{\dagger}f=\underset{\lambda}{\min}\{\lambda | \lambda-f^T M^{\dagger}f \geq 0, f\in\range(M),M\succeq 0\}
$$
The constraints are equivalent to a single matrice inequality, by virtus of Schur's decomposition :
$$
\lambda-f^T M^{\dagger}f \geq 0, f\in\range(M),M\succeq 0 \iff \begin{bmatrix}
    \lambda & f^T \\
    f & M
\end{bmatrix}\succeq 0
$$
This is very interesting in the case where $M$ and $f$ are polynomials, since the matrix inequality that we derive in the end is under the form of LMI or PMI whose degrees donot depend on the dimension of the matrix.

Consider now the bilinear form defined by $M^\dagger$, for all pair of vectors $f,g$, we are interested in the expression $g^T M^\dagger f$. $M$ being a symmetric matrix, $M^\dagger$ is also a symmetric matrix, thus:
$$
g^T M^\dagger f =\frac{1}{2}\Big((f+g)^TM^\dagger(f+g)-g^TM^\dagger g^T-f^T M^\dagger f\Big)
$$
for each term of the right-hand side of the identity, we introduce $\lambda_1,\lambda_2,\lambda_3$ in a similar manner such that :
$$
g^T M^\dagger f=\frac{1}{2}(\lambda_1-\lambda_2-\lambda_3).
$$

This idea, especially the case of bilinear form, could be applied to the expression of $f(t)^T v(t)$. We will be possibly dealing with a bilevel POP problem but with several lower level problems and we are in the case of general constraints $h(x,w)$ as described in \cite{jeyakumar_convergent_2016}.

\subsection{Dealing with higher frequency load}
The discussion of previous subsub section is only valide for sdp matrices. If we add the constraints $K(a)-k^2M(a)\succeq 0$ for all $k$, we expect that highest frequency of the load is inferior to the smallest natural frequency of the structure. Indeed, only the constraint $K(a)-N^2M(a)$ is required to ensure sdp-ness of every matrix, if $N$ is the highest frequency number. To see this, we note that :
$$
K-k^2M=K-(k+1)^2M+\underbrace{(2k+1)M}_{\text{is sdp matrix}},
$$
then $K(a)-k^2M(a)\succeq K(a)-(k+1)^2M(a)$, by induction, $K(a)-k^2M(a)\succeq K(a)-N^2M(a)$

To bypass this limitation, we might propose to find an exact formula or an approximation of the pseudo inverse of $K(a)-k^2M(a)$ using pseudo-inverse of $K$ and $M$, which are sdp matrices. Next step, we apply the idea previously discussed. 

\MT{The case when the resonance frequency is higher than the frequencies of the loads obtained by Fourier expansion is not entirely general but in several applications such cases occur. Thus, while $K-k^2M\succeq0$ is limiting, it still makes sense to discuss/try computationally.}

\subsection{LP expression of the lower problem}
The lower problem can be reduced to optimization of a linear function over a non linear feasible set. Let $(a_i)\in\mathbb{R}^n$ be the vector of optimization variables, if $f$ is composed by $N$ harmonics, then there are sequences of functions $\alpha_k$ and $\beta_k$ for $k=1,...,2N$ such that:
$$
f(t)^Tv(t)=\sum_{k=1}^{2N} \alpha_k(a)\cos(kt)+\beta_k(a)\sin(kt)
$$

The lower level problem is to solve for each feasible $a$
$$
C(a)=\underset{t}{\max} ~ f(t)^Tv(t),
$$
the first idea was to replace $\cos(kt)$ and $\sin(kt)$ by polynomials in terms of $\cos(t)$ and $\sin(t)$. Now we propose to replace each of the $\cos(kt)$ and $\sin(kt)$ by a pair of variables $x_k$ and $y_k$ and add equality constraints to copy exactly the behaviour of trigonometric functions. Considering $x,y\in\mathbb{R}^{2N}$, we propose the following problem :
\begin{align}
    \begin{split}
        \underset{x,y}{\max} & ~\alpha(a)^Tx+\beta(a)^Ty \\
        \text{ s.t. } & \left\{\begin{array}{c}
             x_1^2+y_1^2=1\\
             x_{i+1} = x_{i}x_1-y_{i}y_{1}, \forall i=1,\dots,2N-1\\
             y_{i+1} = x_{i}y_1+y_{i}x_1,\forall i=1,\dots,2N-1
        \end{array}\right.
    \end{split}
\end{align}
which consists of maximizaing a linear function over a non linear feasible set. If there is indeed a solution, we can find $t\in[0,2\pi]$ such that $\cos(jt)=x_j,\sin(jt)=y_j$ for every $j$.

It seems that this new formulation can be solved more efficiently, even if the number of variables and of equality constraints increased. In exchange, the objective function is linear in $x,y$.

\subsection{Maximizing absolute value}
In fact, in the litterature, the peak power is defined as the maximal value of the absolute value of $f(t)^TV(t)$, this is ignored in the current draft but it's possible to fix it.

Let's define an abstract constrainted optimization problem :
\begin{equation}\label{eq:max absf}
    \begin{array}{cc}
        \underset{x}{\max} & |f(x)|  \\
         \text{ s.t. } & x\in X
    \end{array}
\end{equation}

The first approach is due to the monotony of $x\mapsto x^2$ for positive $x$, to maximize the absolute value it suffits to maximize $f(x)^2$.

On the other hand, we intent to give another equivalent to the problem of maximizing absolute value. We observe that for any real number $k$, the aboslute value $|k|$ is the result of the following optimization problem:
$$
\begin{array}{cc}
    \underset{p\in\mathbb{R}}{\max} & pk  \\
     \text{ s.t. } & -1\leq p \leq 1
\end{array}
$$
Which is a linear programming problem over a convex set, the solution is taken on the extremal point of the convex set, $-1$ or $1$ in this case and we know that $|k|=\max\{-k,k\}$. As a result, the following problem :
\begin{equation}\label{eq:max pfx}
    \begin{array}{cc}
        \underset{p\in\mathbb{R},x}{\max} & pf(x)  \\
         \text{ s.t. } & \left\{\begin{array}{c}
              -1\leq p \leq 1  \\
              x\in X 
         \end{array}\right.
    \end{array}
\end{equation}
is equivalent to the problem of maximizing absolute value of $f$ over $X$.
If $(p^*,x^*)$ is a global solution of (\ref{eq:max pfx}), then for all $p\in[-1,1]$, there is :
$$
pf(x^*)\leq p^*f(x^*).
$$
By taking the maximum value over $p$ of both side, we see that :
$$
|f(x^*)|\leq p^*f(x^*)
$$
On the other hand, 
$$
\left\{\begin{array}{c}
     -1\leq p^* \leq 1  \\
     -|f(x^*)|\leq f(x^*) \leq |f(x^*)| 
\end{array}\right.\implies p^*f(x^*)\leq |f(x^*)|.
$$
We conclude that $p^*f(x^*)=|f(x^*)|$. Now consider any feasible $(p,x)$, we have:
$$
pf(x)\leq p^*f(x^*)=|f(x^*)|.
$$
Again by taking max over $p$, we can see that :
$$
\forall x\in X, |f(x)|\leq |f(x^*)|
$$
So $x^*$ is a global solution of (\ref{eq:max absf}).

In the context of polynomial optimization, when $f$ is a polynomial, we can maximize its absolute value over $X$ at the cost of introducing one more variable $p$, rather than double the degree of the polynomial.
\subsection{fast computation of $f^TV$}
As shown in \cite{lofberg_coefficients_2004}, a finite real valued Fourier serie with $N$ harmonics can be equivalently represented by its sampled values at at least $2N+1$ equidistant points in $[-\pi,\pi]$. For instance, if $f(t)=\sum_{n=-N}^{N}c_n(f)e^{int}$ then:
\begin{equation}
    f(t)=\sum_{k=-N}^Nf(k\tau)K_{2N+1}(t-k\tau),
\end{equation}
where :
\begin{itemize}
    \item $\tau=\frac{2\pi}{2N+1}$, the sampled points
    \item $K_{m}$ is the $m$-th Dirichlet kernel and it satisfies:
    $$
    K_{m}(t)=\frac{1}{m}\frac{\sin\frac{mt}{2}}{\sin{\frac{t}{2}}}
    $$
    and $K_m(0)=1$ and $K_m(2k\pi/m)=0$ otherwise $k\neq 0$. Thus $K_{2N+1}(t-k\tau)$ is interpolating iff $t=k\tau$.
\end{itemize}
This gives an efficient way to compute $f(t)^TV(t)$, which is a real scale finite Fourier serie with $2N$ harmonics. We need to sample $f$ and $V$ at $\tau=\frac{2k\pi}{4N+1}$ for $k=-2N,\dots,2N$, which can be generated by Fast Fourier transform and we perform $4N+1$ inner products $f(k\tau)^TV(k\tau)$. In fact:
\begin{equation}
    \begin{bmatrix}
    f(-2N\tau)^T\\
    \vdots\\
    f(0)^T\\
    \vdots\\
    f(2N\tau)^T
    \end{bmatrix}= \begin{bmatrix}
        e^{-2N\tau\times (-N) i}&\dots&1&\dots&e^{-2N\tau\times N i}\\
        \vdots & ~ & \vdots & ~ & \vdots \\
        1 & \dots & 1 & \dots & 1 \\
        \vdots & ~ & \vdots & ~ & \vdots \\
        e^{2N\tau\times (-N) i}&\dots&1&\dots&e^{2N\tau\times N i}
    \end{bmatrix}\begin{bmatrix}
        c_{-N}(f)^T\\
        \vdots\\
        c_{0}(f)^T\\
        \vdots\\
        c_{N}(f)^T
    \end{bmatrix}
\end{equation}
Let's note $E\in\mathbb{C}^{(4N+1)\times(2N+1)}$ such that $E_{k,l}=e^{k\tau li}$


\printbibliography

\end{document}


